

#################
# W3C slide maker
#

# sub and gsub don't work in windows gawk.exe !!
# report bugs to stephan@w3.org


BEGIN {
  FS="<";
  slideFile= "/dev/null";
  overview = "overview.htm";
  all   = "all.htm";
  html  = ".htm";
  logolink = "http://www.w3.org/";
  left  = "../Icons/left.gif";
  right = "../Icons/right.gif";
  top   = "../Icons/up.gif";
  if (length(author_url)>0) author=sprintf("<A HREF=\"%s\">%s</A>", author_url, author) ;
  if (length(logo)==0) logo = "../Icons/w3c_home.gif";
  if (length(style_sheet)==0) style_sheet = "../Tools/w3ctalk.css";

  if (length(author2)>0) {
     if (length(author_url2)>0) author2=sprintf("<A HREF=\"%s\">%s</A>", author_url2, author2);
     author=sprintf("%s, %s", author, author2);
  }

# Body attributes
  battr="BGCOLOR=\"#000060\" TEXT=\"#ffffff\" LINK=\"#ffffe8\" VLINK=\"#eeffee\" ALINK=\"#FF0000\"";

# Style sheet attributes in a separate file
  sattr="<LINK HREF=\"" style_sheet "\" REL=STYLESHEET TYPE=\"text/css\" TITLE=\"W3C Talk\">"

# Parsing state:
# 0: start
# 2: title done
# 3: in slide
# 4: slide done (loops back to 1)

  slideState = 0 ;
  slideCount = 0 ;
  rightButton = "" ;
  openSlideList() ;
}


function closeSlide() { 
  print "<HR class=bottom>\n<TABLE BORDER=\"0\" WIDTH=\"100%\" VALIGN=\"bottom\">" > slideFile ;
  print"<TD><P class=author><I><SMALL>" author "</SMALL></I></TD>" > slideFile ;
  print "<TD ALIGN=\"center\"><A HREF=\"" logolink "\"><b><em>" logolink "</b></em></A>" > slideFile ; 
  print "<TD ALIGN=\"right\"><A HREF=\"" logolink "\"><IMG SRC=\"" logo "\" BORDER=\"0\" ALT=\"W3C\"></A>" > slideFile ; 
  print "</TD></TR></TABLE>" > slideFile ;
  print "</FONT>\n</BODY>\n</HTML>" > slideFile ;
  close(slideFile) ;
}


function openSlide(number, title) {
  print "Opening slide [" number "]: " title
  # Set the slide file name
  slideFile = "slide" number html;
  # Emit the slide header
  print "<HTML>\n<HEAD>\n<TITLE>" talkTitle " - slide " number "</TITLE>" > slideFile ;
  print sattr "\n</HEAD>" > slideFile ;
  print "<BODY " battr ">" > slideFile ;
  # Emit the slide title
  print "<BASEFONT SIZE=" ps ">" > slideFile ;
  print "<TABLE BORDER=\"0\" WIDTH=\"100%\"><TR VALIGN=\"top\">" > slideFile ;
  print "<TD ALIGN=\"left\"><H1 CLASS=\"slide\"><FONT COLOR=\"yellow\">" title "</FONT></H1></TD>" > slideFile ;


  navBar = "<TD ALIGN=\"right\" NOWRAP>"
  # The left button if needed
  if ( slideCount > 1 ) {
  navBar = sprintf("%s\n%s", navBar, "<A HREF=\"slide" (slideCount-1) html "\"><IMG SRC=\"" left "\" BORDER=\"0\" ALT=\"left\"></A>")
  }
  # The top button
  navBar = sprintf("%s\n%s", navBar, "<A HREF=\"" overview "\"><IMG SRC=\"" top "\" BORDER=\"0\" ALT=\"top\"></A>")

  # The right button - last slide is corrected in CorrectLastSlide
  rightButton = sprintf("%s","<A HREF=\"slide" (slideCount+1) html "\"><IMG SRC=\"" right "\" BORDER=\"0\" ALT=\"right\"></A>")
  navBar = sprintf("%s\n%s", navBar, rightButton) ;

  print navBar > slideFile ;
  print "</TD></TR></TABLE>\n<HR class=top>" > slideFile ;
  # Add the slide to the list:
  addSlide(number, title);
}


function openSlideList() {
  slideList = overview;
  talkTitle = title ;
  print "<HTML>\n<HEAD>\n<TITLE>" talkTitle ": Slide list</TITLE>" > slideList;
  print sattr "\n</HEAD>" > slideList ;
  print "<BODY " battr ">" > slideList ;
  print "<FONT COLOR=\"yellow\"><CENTER><H1 CLASS=\"slidelist\">" talkTitle > slideList ;
  print "<BR><SMALL>by</SMALL> <I>" author "</I>" > slideList ;
  print "</H1></CENTER></FONT>\n" > slideList;
  print "<BLOCKQUOTE><H2>Table of Contents</H2>" > slideList;
  print "<OL>" > slideList;
}


function closeSlideList() {
  print "</OL></BLOCKQUOTE>" > slideList;
  print "<HR><TABLE BORDER=\"0\" WIDTH=\"100%\"><TR VALIGN=\"top\">" > slideList ;
  print "<TD ALIGN=\"right\"><A HREF=\"http://www.w3.org/\"><IMG SRC=\"" logo "\" ALIGN=\"bottom\" BORDER=\"0\" ALT=\"W3C\"></A></TD>" > slideList ;
  print "</TR></TABLE>" > slideList ;
  print "</HTML>" > slideList;
  close(slideList);
}


function addSlide(number, title) {
  print"<LI><A HREF=\"slide" number html "\">" title "</A></LI>" > slideList;
}


function correctLastSlide(last) {
  lastFile = "slide" last html ;
  newFile = "slide" last ".new" ;
  do {
    getline line < lastFile ;
    if (match(line, rightButton) == 0) {
          print line > newFile;
    }
  }
  while (line != "</HTML>") ;
  close(lastFile) ;
  close(newFile) ;

  if (arch == "PC") {
          system("del " lastFile) ;
          system("move " newFile " " lastFile) ;
  } else {
          system("mv -f " newFile " " lastFile) ;
  }
}


function ifopenSlide(slideTitle) {
  while (substr(slideTitle,1,1) == " ") {
      slideTitle = substr(slideTitle, 2);
  }
  if (length(slideTitle)>0) {
    openSlide(++slideCount, slideTitle);
    slideState = 3;
  }
}

# <h1> and no </h1>
/<[hH]1>/ && ! /<\/[hH]1>/ { 
  if ( slideState == 3 ) {
    # Close current slide
    closeSlide() ;
    slideState = 2 ; 
  } else if ( slideState == 0 ) {
    slideState = 2 ;
  } else {
    print "[1] Invalid state: " slideState ;
  }
  slideTitle = substr($2,4);
  ifopenSlide(slideTitle);
}

# </h1> and no <h1>
/<\/[hH]1>/ && ! /<[hH]1>/ {
  if ( slideState == 2) {
  slideTitle = $1;
  ifopenSlide(slideTitle);
  } else if ( slideState != 3 ) {
    print "[2] Invalid state " slideState ;
  }
}

# <h1> and </h1>
/<[hH]1>/ && /<\/[hH]1>/ { 
  if ( slideState == 3 ) {
# Close current slide
    closeSlide() ;
  }
    slideTitle = substr($2,4);
    ifopenSlide(slideTitle);
}


# no h1> and no </BODY> or </HTML>
# warning: lines like "text blablabla</BODY></HTML> will be lost"
! /[hH]1>/ && ! /<\/[bB][oO][dD][yY]>/ && ! /<\/[hH][tT][mM][lL]>/  { 
  if ( slideState == 2 ) {
    slideTitle = $0 ;
    ifopenSlide(slideTitle);
  } else if (slideState == 3) {
    print > slideFile ;
  } else {
    # print "[3] Invalid state: " slideState " in " $0 ;
  }
}

END {
  closeSlide() ;
  closeSlideList() ;
  correctLastSlide(slideCount) ;
}
